<template>
  <div class="canvas" :style="{ height: canvasheight, width: canvaswidth }">
    <Node
      :nodedata="state"
      v-for="state in states"
      :key="state.name"
      :id="state.name"
      @dragEvent="handleDragEvent"
    />
  </div>
</template>

<script>
import Node from "./components/Node.vue";
import { provide, ref } from "vue";

export default {
  name: "App",
  setup() {
    const canvasheight = "90vh";
    const canvaswidth = "90vw";
    const lastDrag = ref(null);

    provide("globalDragEvent", lastDrag);

    const states = [
      { name: "START", actions: [{ next: "ZWEI" }, { next: "ZWEI-A" }] },
      { name: "ZWEI", actions: [{ next: "DREI" }] },
      { name: "DREI", actions: [{ next: "DREI" }] },
      { name: "ZWEI-A" },
    ];

    const handleDragEvent = (e) => {
      //console.log("canvas got drag event", e);
      lastDrag.value = e;
    };

    return {
      states,
      canvasheight,
      canvaswidth,
      handleDragEvent,
    };
  },
  components: {
    Node,
  },
};
</script>

<style>
.canvas {
  position: relative;
}
</style>
